const {EmbedBuilder} = require("discord.js");

const getFooterIcon = (client, message, options) => options
    ? options.footerIcon === "bot"
        ? client.user.avatarURL()
        : options.footerIcon === "user"
            ? message.member
                ? message.member.displayAvatarURL({dynamic: true})
                : message.author.displayAvatarURL({dynamic: true})
            : options.footerIcon === "server"
                ? message.guild
                    ? message.guild.iconURL({dynamic: true})
                    : client.user.avatarURL()
                : client.user.avatarURL()
    : client.user.avatarURL();

module.exports = client => {
    client.embeds = {
        base: (message, options) => new EmbedBuilder()
            .setColor(client.config.embed.colors.base)
            .setFooter({text: client.config.bot.name, iconURL: getFooterIcon(client, message, options)})
            .setTimestamp(),
        success: (message, options) => new EmbedBuilder()
            .setColor(client.config.embed.colors.success)
            .setFooter({text: client.config.bot.name, iconURL: getFooterIcon(client, message, options)})
            .setTimestamp(),
        fail: (message, options) => new EmbedBuilder()
            .setColor(client.config.embed.colors.fail)
            .setFooter({text: client.config.bot.name, iconURL: getFooterIcon(client, message, options)})
            .setTimestamp()
    }
};